"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SWC_VERSION = exports.transform = exports.transformJest = exports.transformSync = void 0;
const path_1 = require("path");
const helper_1 = require("@node-rs/helper");
const bindings = helper_1.loadBinding(path_1.join(require.resolve('@swc-node/core'), '..', '..'), 'swc', '@swc-node/core');
function transformOption(path, options) {
    var _a, _b, _c;
    const opts = options == null ? {} : options;
    opts.esModuleInterop = (_a = opts.esModuleInterop) !== null && _a !== void 0 ? _a : true;
    return JSON.stringify({
        filename: path,
        jsc: {
            target: (_b = opts.target) !== null && _b !== void 0 ? _b : 'es2018',
            parser: {
                syntax: 'typescript',
                tsx: typeof opts.jsx !== 'undefined' ? opts.jsx : path.endsWith('.tsx'),
                decorators: Boolean(opts.experimentalDecorators),
                dynamicImport: Boolean(opts.dynamicImport),
            },
            transform: {
                legacyDecorator: Boolean(opts.experimentalDecorators),
                decoratorMetadata: Boolean(opts.emitDecoratorMetadata),
            },
        },
        isModule: true,
        module: {
            type: (_c = opts.module) !== null && _c !== void 0 ? _c : 'commonjs',
            noInterop: !opts.esModuleInterop,
        },
        sourceMaps: typeof opts.sourcemap === 'undefined' ? true : opts.sourcemap,
        swcrc: false,
    });
}
function transformSync(source, path, options) {
    return bindings.transformSync(source, path, transformOption(path, options));
}
exports.transformSync = transformSync;
function transformJest(source, path, options) {
    return bindings.transformJest(source, path, transformOption(path, options));
}
exports.transformJest = transformJest;
function transform(source, path, options) {
    return bindings.transform(source, path, transformOption(path, options));
}
exports.transform = transform;
exports.SWC_VERSION = '3a26d3d';
//# sourceMappingURL=index.js.map